# encoding: utf-8
# **********************************************************************
#
# Copyright (c) 2003-2016 ZeroC, Inc. All rights reserved.
#
# This copy of Ice is licensed to you under the terms described in the
# ICE_LICENSE file included in this distribution.
#
# **********************************************************************
#
# Ice version 3.6.3
#
# <auto-generated>
#
# Generated from file `Connection.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

require 'Ice'
require 'Ice/ObjectAdapterF.rb'
require 'Ice/Identity.rb'
require 'Ice/Endpoint.rb'

module Ice

    if not defined?(::Ice::ConnectionInfo_mixin)
        module ConnectionInfo_mixin

            def inspect
                ::Ice::__stringify(self, T_ConnectionInfo)
            end

            attr_accessor :incoming, :adapterName, :connectionId, :rcvSize, :sndSize
        end
        class ConnectionInfo
            include ConnectionInfo_mixin
            
            def ConnectionInfo.ice_staticId()
                '::Ice::ConnectionInfo'
            end

            def initialize(incoming=false, adapterName='', connectionId='', rcvSize=0, sndSize=0)
                @incoming = incoming
                @adapterName = adapterName
                @connectionId = connectionId
                @rcvSize = rcvSize
                @sndSize = sndSize
            end
        end

        if not defined?(::Ice::T_ConnectionInfo)
            T_ConnectionInfo = ::Ice::__declareLocalClass('::Ice::ConnectionInfo')
        end

        T_ConnectionInfo.defineClass(ConnectionInfo, -1, false, false, nil, [], [
            ['incoming', ::Ice::T_bool, false, 0],
            ['adapterName', ::Ice::T_string, false, 0],
            ['connectionId', ::Ice::T_string, false, 0],
            ['rcvSize', ::Ice::T_int, false, 0],
            ['sndSize', ::Ice::T_int, false, 0]
        ])
        ConnectionInfo_mixin::ICE_TYPE = T_ConnectionInfo
    end

    if not defined?(::Ice::T_Connection)
        T_Connection = ::Ice::__declareLocalClass('::Ice::Connection')
    end

    if not defined?(::Ice::ConnectionCallback_mixin)
        module ConnectionCallback_mixin

            #
            # Operation signatures.
            #
            # def heartbeat(con)
            # def closed(con)

            def inspect
                ::Ice::__stringify(self, T_ConnectionCallback)
            end
        end
        class ConnectionCallback
            include ConnectionCallback_mixin
            
            def ConnectionCallback.ice_staticId()
                '::Ice::ConnectionCallback'
            end
        end

        if not defined?(::Ice::T_ConnectionCallback)
            T_ConnectionCallback = ::Ice::__declareLocalClass('::Ice::ConnectionCallback')
        end

        T_ConnectionCallback.defineClass(ConnectionCallback, -1, true, false, nil, [], [])
        ConnectionCallback_mixin::ICE_TYPE = T_ConnectionCallback
    end

    if not defined?(::Ice::ACMClose)
        class ACMClose
            include Comparable

            def initialize(name, value)
                @name = name
                @value = value
            end

            def ACMClose.from_int(val)
                @@_enumerators[val]
            end

            def to_s
                @name
            end

            def to_i
                @value
            end

            def <=>(other)
                other.is_a?(ACMClose) or raise ArgumentError, "value must be a ACMClose"
                @value <=> other.to_i
            end

            def hash
                @value.hash
            end

            def inspect
                @name + "(#{@value})"
            end

            def ACMClose.each(&block)
                @@_enumerators.each_value(&block)
            end

            CloseOff = ACMClose.new("CloseOff", 0)
            CloseOnIdle = ACMClose.new("CloseOnIdle", 1)
            CloseOnInvocation = ACMClose.new("CloseOnInvocation", 2)
            CloseOnInvocationAndIdle = ACMClose.new("CloseOnInvocationAndIdle", 3)
            CloseOnIdleForceful = ACMClose.new("CloseOnIdleForceful", 4)

            @@_enumerators = {0=>CloseOff, 1=>CloseOnIdle, 2=>CloseOnInvocation, 3=>CloseOnInvocationAndIdle, 4=>CloseOnIdleForceful}

            def ACMClose._enumerators
                @@_enumerators
            end

            private_class_method :new
        end

        T_ACMClose = ::Ice::__defineEnum('::Ice::ACMClose', ACMClose, ACMClose::_enumerators)
    end

    if not defined?(::Ice::ACMHeartbeat)
        class ACMHeartbeat
            include Comparable

            def initialize(name, value)
                @name = name
                @value = value
            end

            def ACMHeartbeat.from_int(val)
                @@_enumerators[val]
            end

            def to_s
                @name
            end

            def to_i
                @value
            end

            def <=>(other)
                other.is_a?(ACMHeartbeat) or raise ArgumentError, "value must be a ACMHeartbeat"
                @value <=> other.to_i
            end

            def hash
                @value.hash
            end

            def inspect
                @name + "(#{@value})"
            end

            def ACMHeartbeat.each(&block)
                @@_enumerators.each_value(&block)
            end

            HeartbeatOff = ACMHeartbeat.new("HeartbeatOff", 0)
            HeartbeatOnInvocation = ACMHeartbeat.new("HeartbeatOnInvocation", 1)
            HeartbeatOnIdle = ACMHeartbeat.new("HeartbeatOnIdle", 2)
            HeartbeatAlways = ACMHeartbeat.new("HeartbeatAlways", 3)

            @@_enumerators = {0=>HeartbeatOff, 1=>HeartbeatOnInvocation, 2=>HeartbeatOnIdle, 3=>HeartbeatAlways}

            def ACMHeartbeat._enumerators
                @@_enumerators
            end

            private_class_method :new
        end

        T_ACMHeartbeat = ::Ice::__defineEnum('::Ice::ACMHeartbeat', ACMHeartbeat, ACMHeartbeat::_enumerators)
    end

    if not defined?(::Ice::ACM)
        class ACM
            def initialize(timeout=0, close=::Ice::ACMClose::CloseOff, heartbeat=::Ice::ACMHeartbeat::HeartbeatOff)
                @timeout = timeout
                @close = close
                @heartbeat = heartbeat
            end

            def hash
                _h = 0
                _h = 5 * _h + @timeout.hash
                _h = 5 * _h + @close.hash
                _h = 5 * _h + @heartbeat.hash
                _h % 0x7fffffff
            end

            def ==(other)
                return false if
                    @timeout != other.timeout or
                    @close != other.close or
                    @heartbeat != other.heartbeat
                true
            end

            def eql?(other)
                return other.class == self.class && other == self
            end

            def inspect
                ::Ice::__stringify(self, T_ACM)
            end

            attr_accessor :timeout, :close, :heartbeat
        end

        T_ACM = ::Ice::__defineStruct('::Ice::ACM', ACM, [
            ["timeout", ::Ice::T_int],
            ["close", ::Ice::T_ACMClose],
            ["heartbeat", ::Ice::T_ACMHeartbeat]
        ])
    end

    if not defined?(::Ice::Connection_mixin)
        module Connection_mixin

            #
            # Operation signatures.
            #
            # def close(force)
            # def createProxy(id)
            # def setAdapter(adapter)
            # def getAdapter()
            # def getEndpoint()
            # def flushBatchRequests()
            # def setCallback(callback)
            # def setACM(timeout, close, heartbeat)
            # def getACM()
            # def type()
            # def timeout()
            # def toString()
            # def getInfo()
            # def setBufferSize(rcvSize, sndSize)

            def inspect
                ::Ice::__stringify(self, T_Connection)
            end
        end
        class Connection
            include Connection_mixin
            
            def Connection.ice_staticId()
                '::Ice::Connection'
            end
        end

        if not defined?(::Ice::T_Connection)
            T_Connection = ::Ice::__declareLocalClass('::Ice::Connection')
        end

        T_Connection.defineClass(Connection, -1, true, false, nil, [], [])
        Connection_mixin::ICE_TYPE = T_Connection
    end

    if not defined?(::Ice::IPConnectionInfo_mixin)
        module IPConnectionInfo_mixin

            def inspect
                ::Ice::__stringify(self, T_IPConnectionInfo)
            end

            attr_accessor :localAddress, :localPort, :remoteAddress, :remotePort
        end
        class IPConnectionInfo
            include IPConnectionInfo_mixin
            
            def IPConnectionInfo.ice_staticId()
                '::Ice::IPConnectionInfo'
            end

            def initialize(incoming=false, adapterName='', connectionId='', rcvSize=0, sndSize=0, localAddress="", localPort=-1, remoteAddress="", remotePort=-1)
                super(incoming, adapterName, connectionId, rcvSize, sndSize)
                @localAddress = localAddress
                @localPort = localPort
                @remoteAddress = remoteAddress
                @remotePort = remotePort
            end
        end

        if not defined?(::Ice::T_IPConnectionInfo)
            T_IPConnectionInfo = ::Ice::__declareLocalClass('::Ice::IPConnectionInfo')
        end

        T_IPConnectionInfo.defineClass(IPConnectionInfo, -1, false, false, nil, [], [
            ['localAddress', ::Ice::T_string, false, 0],
            ['localPort', ::Ice::T_int, false, 0],
            ['remoteAddress', ::Ice::T_string, false, 0],
            ['remotePort', ::Ice::T_int, false, 0]
        ])
        IPConnectionInfo_mixin::ICE_TYPE = T_IPConnectionInfo
    end

    if not defined?(::Ice::TCPConnectionInfo_mixin)
        module TCPConnectionInfo_mixin

            def inspect
                ::Ice::__stringify(self, T_TCPConnectionInfo)
            end
        end
        class TCPConnectionInfo
            include TCPConnectionInfo_mixin
            
            def TCPConnectionInfo.ice_staticId()
                '::Ice::TCPConnectionInfo'
            end

            def initialize(incoming=false, adapterName='', connectionId='', rcvSize=0, sndSize=0, localAddress="", localPort=-1, remoteAddress="", remotePort=-1)
                super(incoming, adapterName, connectionId, rcvSize, sndSize, localAddress, localPort, remoteAddress, remotePort)
            end
        end

        if not defined?(::Ice::T_TCPConnectionInfo)
            T_TCPConnectionInfo = ::Ice::__declareLocalClass('::Ice::TCPConnectionInfo')
        end

        T_TCPConnectionInfo.defineClass(TCPConnectionInfo, -1, false, false, nil, [], [])
        TCPConnectionInfo_mixin::ICE_TYPE = T_TCPConnectionInfo
    end

    if not defined?(::Ice::UDPConnectionInfo_mixin)
        module UDPConnectionInfo_mixin

            def inspect
                ::Ice::__stringify(self, T_UDPConnectionInfo)
            end

            attr_accessor :mcastAddress, :mcastPort
        end
        class UDPConnectionInfo
            include UDPConnectionInfo_mixin
            
            def UDPConnectionInfo.ice_staticId()
                '::Ice::UDPConnectionInfo'
            end

            def initialize(incoming=false, adapterName='', connectionId='', rcvSize=0, sndSize=0, localAddress="", localPort=-1, remoteAddress="", remotePort=-1, mcastAddress='', mcastPort=-1)
                super(incoming, adapterName, connectionId, rcvSize, sndSize, localAddress, localPort, remoteAddress, remotePort)
                @mcastAddress = mcastAddress
                @mcastPort = mcastPort
            end
        end

        if not defined?(::Ice::T_UDPConnectionInfo)
            T_UDPConnectionInfo = ::Ice::__declareLocalClass('::Ice::UDPConnectionInfo')
        end

        T_UDPConnectionInfo.defineClass(UDPConnectionInfo, -1, false, false, nil, [], [
            ['mcastAddress', ::Ice::T_string, false, 0],
            ['mcastPort', ::Ice::T_int, false, 0]
        ])
        UDPConnectionInfo_mixin::ICE_TYPE = T_UDPConnectionInfo
    end

    if not defined?(::Ice::T_HeaderDict)
        T_HeaderDict = ::Ice::__defineDictionary('::Ice::HeaderDict', ::Ice::T_string, ::Ice::T_string)
    end

    if not defined?(::Ice::WSConnectionInfo_mixin)
        module WSConnectionInfo_mixin

            def inspect
                ::Ice::__stringify(self, T_WSConnectionInfo)
            end

            attr_accessor :headers
        end
        class WSConnectionInfo
            include WSConnectionInfo_mixin
            
            def WSConnectionInfo.ice_staticId()
                '::Ice::WSConnectionInfo'
            end

            def initialize(incoming=false, adapterName='', connectionId='', rcvSize=0, sndSize=0, localAddress="", localPort=-1, remoteAddress="", remotePort=-1, headers=nil)
                super(incoming, adapterName, connectionId, rcvSize, sndSize, localAddress, localPort, remoteAddress, remotePort)
                @headers = headers
            end
        end

        if not defined?(::Ice::T_WSConnectionInfo)
            T_WSConnectionInfo = ::Ice::__declareLocalClass('::Ice::WSConnectionInfo')
        end

        T_WSConnectionInfo.defineClass(WSConnectionInfo, -1, false, false, nil, [], [['headers', ::Ice::T_HeaderDict, false, 0]])
        WSConnectionInfo_mixin::ICE_TYPE = T_WSConnectionInfo
    end
end
