# encoding: utf-8
# **********************************************************************
#
# Copyright (c) 2003-2016 ZeroC, Inc. All rights reserved.
#
# This copy of Ice is licensed to you under the terms described in the
# ICE_LICENSE file included in this distribution.
#
# **********************************************************************
#
# Ice version 3.6.3
#
# <auto-generated>
#
# Generated from file `RemoteLogger.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

require 'Ice'
require 'Ice/BuiltinSequences.rb'

module Ice

    if not defined?(::Ice::LogMessageType)
        class LogMessageType
            include Comparable

            def initialize(name, value)
                @name = name
                @value = value
            end

            def LogMessageType.from_int(val)
                @@_enumerators[val]
            end

            def to_s
                @name
            end

            def to_i
                @value
            end

            def <=>(other)
                other.is_a?(LogMessageType) or raise ArgumentError, "value must be a LogMessageType"
                @value <=> other.to_i
            end

            def hash
                @value.hash
            end

            def inspect
                @name + "(#{@value})"
            end

            def LogMessageType.each(&block)
                @@_enumerators.each_value(&block)
            end

            PrintMessage = LogMessageType.new("PrintMessage", 0)
            TraceMessage = LogMessageType.new("TraceMessage", 1)
            WarningMessage = LogMessageType.new("WarningMessage", 2)
            ErrorMessage = LogMessageType.new("ErrorMessage", 3)

            @@_enumerators = {0=>PrintMessage, 1=>TraceMessage, 2=>WarningMessage, 3=>ErrorMessage}

            def LogMessageType._enumerators
                @@_enumerators
            end

            private_class_method :new
        end

        T_LogMessageType = ::Ice::__defineEnum('::Ice::LogMessageType', LogMessageType, LogMessageType::_enumerators)
    end

    if not defined?(::Ice::T_LogMessageTypeSeq)
        T_LogMessageTypeSeq = ::Ice::__defineSequence('::Ice::LogMessageTypeSeq', ::Ice::T_LogMessageType)
    end

    if not defined?(::Ice::LogMessage)
        class LogMessage
            def initialize(type=::Ice::LogMessageType::PrintMessage, timestamp=0, traceCategory='', message='')
                @type = type
                @timestamp = timestamp
                @traceCategory = traceCategory
                @message = message
            end

            def hash
                _h = 0
                _h = 5 * _h + @type.hash
                _h = 5 * _h + @timestamp.hash
                _h = 5 * _h + @traceCategory.hash
                _h = 5 * _h + @message.hash
                _h % 0x7fffffff
            end

            def ==(other)
                return false if
                    @type != other.type or
                    @timestamp != other.timestamp or
                    @traceCategory != other.traceCategory or
                    @message != other.message
                true
            end

            def eql?(other)
                return other.class == self.class && other == self
            end

            def inspect
                ::Ice::__stringify(self, T_LogMessage)
            end

            attr_accessor :type, :timestamp, :traceCategory, :message
        end

        T_LogMessage = ::Ice::__defineStruct('::Ice::LogMessage', LogMessage, [
            ["type", ::Ice::T_LogMessageType],
            ["timestamp", ::Ice::T_long],
            ["traceCategory", ::Ice::T_string],
            ["message", ::Ice::T_string]
        ])
    end

    if not defined?(::Ice::T_LogMessageSeq)
        T_LogMessageSeq = ::Ice::__defineSequence('::Ice::LogMessageSeq', ::Ice::T_LogMessage)
    end

    if not defined?(::Ice::RemoteLogger_mixin)
        module RemoteLogger_mixin
            include ::Ice::Object_mixin

            def ice_ids(current=nil)
                ['::Ice::Object', '::Ice::RemoteLogger']
            end

            def ice_id(current=nil)
                '::Ice::RemoteLogger'
            end

            #
            # Operation signatures.
            #
            # def init(prefix, logMessages, current=nil)
            # def log(message, current=nil)

            def inspect
                ::Ice::__stringify(self, T_RemoteLogger)
            end
        end
        class RemoteLogger
            include RemoteLogger_mixin
            
            def RemoteLogger.ice_staticId()
                '::Ice::RemoteLogger'
            end
        end
        module RemoteLoggerPrx_mixin

            def init(prefix, logMessages, _ctx=nil)
                RemoteLogger_mixin::OP_init.invoke(self, [prefix, logMessages], _ctx)
            end

            def log(message, _ctx=nil)
                RemoteLogger_mixin::OP_log.invoke(self, [message], _ctx)
            end
        end
        class RemoteLoggerPrx < ::Ice::ObjectPrx
            include RemoteLoggerPrx_mixin

            def RemoteLoggerPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
                ice_checkedCast(proxy, '::Ice::RemoteLogger', facetOrCtx, _ctx)
            end

            def RemoteLoggerPrx.uncheckedCast(proxy, facet=nil)
                ice_uncheckedCast(proxy, facet)
            end
            def RemoteLoggerPrx.ice_staticId()
                '::Ice::RemoteLogger'
            end
        end

        if not defined?(::Ice::T_RemoteLogger)
            T_RemoteLogger = ::Ice::__declareClass('::Ice::RemoteLogger')
            T_RemoteLoggerPrx = ::Ice::__declareProxy('::Ice::RemoteLogger')
        end

        T_RemoteLogger.defineClass(RemoteLogger, -1, true, false, nil, [], [])
        RemoteLogger_mixin::ICE_TYPE = T_RemoteLogger

        T_RemoteLoggerPrx.defineProxy(RemoteLoggerPrx, T_RemoteLogger)
        RemoteLoggerPrx::ICE_TYPE = T_RemoteLoggerPrx

        RemoteLogger_mixin::OP_init = ::Ice::__defineOperation('init', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, nil, [[::Ice::T_string, false, 0], [::Ice::T_LogMessageSeq, false, 0]], [], nil, [])
        RemoteLogger_mixin::OP_log = ::Ice::__defineOperation('log', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, nil, [[::Ice::T_LogMessage, false, 0]], [], nil, [])
    end

    if not defined?(::Ice::RemoteLoggerAlreadyAttachedException)
        class RemoteLoggerAlreadyAttachedException < Ice::UserException
            def initialize
            end

            def to_s
                'Ice::RemoteLoggerAlreadyAttachedException'
            end
        end

        T_RemoteLoggerAlreadyAttachedException = ::Ice::__defineException('::Ice::RemoteLoggerAlreadyAttachedException', RemoteLoggerAlreadyAttachedException, false, nil, [])
        RemoteLoggerAlreadyAttachedException::ICE_TYPE = T_RemoteLoggerAlreadyAttachedException
    end

    if not defined?(::Ice::LoggerAdmin_mixin)
        module LoggerAdmin_mixin
            include ::Ice::Object_mixin

            def ice_ids(current=nil)
                ['::Ice::LoggerAdmin', '::Ice::Object']
            end

            def ice_id(current=nil)
                '::Ice::LoggerAdmin'
            end

            #
            # Operation signatures.
            #
            # def attachRemoteLogger(prx, messageTypes, traceCategories, messageMax, current=nil)
            # def detachRemoteLogger(prx, current=nil)
            # def getLog(messageTypes, traceCategories, messageMax, current=nil)

            def inspect
                ::Ice::__stringify(self, T_LoggerAdmin)
            end
        end
        class LoggerAdmin
            include LoggerAdmin_mixin
            
            def LoggerAdmin.ice_staticId()
                '::Ice::LoggerAdmin'
            end
        end
        module LoggerAdminPrx_mixin

            def attachRemoteLogger(prx, messageTypes, traceCategories, messageMax, _ctx=nil)
                LoggerAdmin_mixin::OP_attachRemoteLogger.invoke(self, [prx, messageTypes, traceCategories, messageMax], _ctx)
            end

            def detachRemoteLogger(prx, _ctx=nil)
                LoggerAdmin_mixin::OP_detachRemoteLogger.invoke(self, [prx], _ctx)
            end

            def getLog(messageTypes, traceCategories, messageMax, _ctx=nil)
                LoggerAdmin_mixin::OP_getLog.invoke(self, [messageTypes, traceCategories, messageMax], _ctx)
            end
        end
        class LoggerAdminPrx < ::Ice::ObjectPrx
            include LoggerAdminPrx_mixin

            def LoggerAdminPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
                ice_checkedCast(proxy, '::Ice::LoggerAdmin', facetOrCtx, _ctx)
            end

            def LoggerAdminPrx.uncheckedCast(proxy, facet=nil)
                ice_uncheckedCast(proxy, facet)
            end
            def LoggerAdminPrx.ice_staticId()
                '::Ice::LoggerAdmin'
            end
        end

        if not defined?(::Ice::T_LoggerAdmin)
            T_LoggerAdmin = ::Ice::__declareClass('::Ice::LoggerAdmin')
            T_LoggerAdminPrx = ::Ice::__declareProxy('::Ice::LoggerAdmin')
        end

        T_LoggerAdmin.defineClass(LoggerAdmin, -1, true, false, nil, [], [])
        LoggerAdmin_mixin::ICE_TYPE = T_LoggerAdmin

        T_LoggerAdminPrx.defineProxy(LoggerAdminPrx, T_LoggerAdmin)
        LoggerAdminPrx::ICE_TYPE = T_LoggerAdminPrx

        LoggerAdmin_mixin::OP_attachRemoteLogger = ::Ice::__defineOperation('attachRemoteLogger', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, nil, [[::Ice::T_RemoteLoggerPrx, false, 0], [::Ice::T_LogMessageTypeSeq, false, 0], [::Ice::T_StringSeq, false, 0], [::Ice::T_int, false, 0]], [], nil, [::Ice::T_RemoteLoggerAlreadyAttachedException])
        LoggerAdmin_mixin::OP_detachRemoteLogger = ::Ice::__defineOperation('detachRemoteLogger', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, nil, [[::Ice::T_RemoteLoggerPrx, false, 0]], [], [::Ice::T_bool, false, 0], [])
        LoggerAdmin_mixin::OP_getLog = ::Ice::__defineOperation('getLog', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, nil, [[::Ice::T_LogMessageTypeSeq, false, 0], [::Ice::T_StringSeq, false, 0], [::Ice::T_int, false, 0]], [[::Ice::T_string, false, 0]], [::Ice::T_LogMessageSeq, false, 0], [])
    end
end
